#include "ai.h"
#include "ai.moc"

#include <klocale.h>

#include "board.h"


const AI::Data FEAI::DATA[] = {
    { "occupied lines", I18N_NOOP("Occupied lines:"), 0,
      -100.0, 0.0, -2.0, false, 0, 0, 0, nbOccupiedLines },
    { "spaces", I18N_NOOP("Number of spaces:"), I18N_NOOP("Number of spaces under mean height"),
      -100.0, 0.0, 0.0, false, 0, 0, 0, nbSpaces },
    { "peak-to-peak", I18N_NOOP("Peak-to-peak distance:"), 0,
      -100.0, 0.0, 0.0, false, 0, 0, 0, peakToPeak },
    { "mean height", I18N_NOOP("Mean height:"), 0,
      -100.0, 0.0, 0.0, false, 0, 0, 0, mean },
    { "removed eggs", I18N_NOOP("Number of removed eggs:"), 0,
      0.0, 100.0, 20.0, false, 0, 0, 0, nbRemoved },
    { "nb puyos", I18N_NOOP("Number of puyos:"), 0,
      0.0, 100.0, 50.0, true, 0, 10, 0, nbPuyos },
    { "nb chained", I18N_NOOP("Number of chained puyos:"), 0,
      0.0, 100.0, 80.0, true, 0, 10, 0, nbChained },
    LastData
};

FEAI::FEAI()
: AI(0, 200, DATA)
{}

double FEAI::nbPuyos(const Board &main, const Board &current)
{
    return static_cast<const FEBoard &>(current).nbPuyos()
        - static_cast<const FEBoard &>(main).nbPuyos();
}

double FEAI::nbChained(const Board &, const Board &current)
{
    return static_cast<const FEBoard &>(current).chained();
}
